<script>
import { ref, onMounted } from "vue";
import { useRouter } from "vue-router";
import axios from "axios";

export default {
  setup() {
    const books = ref([]);
    const genres = ref({});

    const router = useRouter();

    const fetchBooks = () => {
      axios
        .get("http://localhost:8000/api/buku")
        .then((response) => {
          books.value = response.data;
        })
        .catch((error) => {
          console.error("Error fetching books:", error);
        });
    };

    const fetchGenres = () => {
      axios
        .get("http://localhost:8000/api/genre")
        .then((response) => {
          const genresData = response.data;
          genres.value = genresData.reduce((acc, genre) => {
            acc[genre.genre_id] = genre.genre;
            return acc;
          }, {});
        })
        .catch((error) => {
          console.error("Error fetching genres:", error);
        });
    };

    const getGenreName = (genreId) => {
      if (Object.keys(genres.value).length === 0) {
        return "Loading...";
      }
      return genres.value[genreId] || "Unknown";
    };

    const formatPrice = (price) => {
      return new Intl.NumberFormat("id-ID", {
        style: "currency",
        currency: "IDR",
      }).format(price);
    };

    const truncateSynopsis = (synopsis) => {
      if (!synopsis) return "";
      const words = synopsis.split(" ");
      if (words.length > 30) {
        return words.slice(0, 30).join(" ") + "...";
      } else {
        return synopsis;
      }
    };

    const editBuku = (id) => {
      router.push(`/admin/edit-buku/${id}`);
    };

    const deleteBuku = (id) => {
      if (confirm("Apakah Anda yakin ingin menghapus buku ini?")) {
        axios
          .delete(`http://localhost:8000/api/buku/${id}`)
          .then((response) => {
            books.value = books.value.filter((book) => book.buku_id !== id);
            alert("Buku berhasil dihapus!");
          })
          .catch((error) => {
            console.error("Error deleting book:", error);
            alert("Gagal menghapus buku. Silakan coba lagi.");
          });
      }
    };

    onMounted(() => {
      fetchBooks();
      fetchGenres();
    });

    return { books, formatPrice, truncateSynopsis, editBuku, deleteBuku };
  },
};
</script>
<template>
  <div class="container mt-3 vh-100 pt-5" id="app" style="min-height: 560px">
    <div class="py-4">
      <a href="/admin/add-buku" class="btn btn-primary mb-2"
        >+ Tambahkan Buku</a
      >
    </div>
    <table class="table table-striped table-hover">
      <thead>
        <tr>
          <th scope="col" style="vertical-align: middle; text-align: center">
            ID
          </th>
          <th scope="col" style="vertical-align: middle; text-align: center">
            Judul Buku
          </th>
          <th scope="col" style="vertical-align: middle; text-align: center">
            Author
          </th>
          <th scope="col" style="vertical-align: middle; text-align: center">
            Cover
          </th>
          <th scope="col" style="vertical-align: middle; text-align: center">
            Harga
          </th>
          <th scope="col" style="vertical-align: middle; text-align: center">
            Aksi
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="book in books" :key="book.buku_id">
          <th scope="row" style="vertical-align: middle; text-align: center">
            {{ book.buku_id }}
          </th>
          <td style="vertical-align: middle">
            {{ book.title }}
          </td>
          <td style="vertical-align: middle">{{ book.author }}</td>
          <td style="vertical-align: middle">
            <img :src="book.cover" alt="Book Cover" width="75" />
          </td>
          <td style="vertical-align: middle">{{ formatPrice(book.price) }}</td>
          <td style="vertical-align: middle">
            <div class="d-grid gap-2 d-md-flex justify-content-md-start">
              <button @click="editBuku(book.buku_id)" class="btn btn-warning">
                Edit
              </button>
              <button @click="deleteBuku(book.buku_id)" class="btn btn-danger">
                Delete
              </button>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>
